/** \file
 * Entry points into the firmware image. 
 * Auto-generated with 500d.py from 500d_110_20100717.idc
 *
 * These are the functions that we can call from our tasks
 * in the Canon 1.0.8 firmware for the 550d.
 *
 * Copyright (C) 2010 Trammell Hudson <hudson+ml@osresearch.net>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

.text

#define NSTUB(addr,name) \
	.global name; \
	name = addr

NSTUB( ROMBASEADDR, firmware_entry )

/** These must be found first for any progress to be made */
NSTUB( 0xFF010894, cstart )
NSTUB( 0xFF3EBC24, bzero32 ) // called by cstart()
NSTUB( 0xFF011DBC, init_task ) // passed as arg to create_init_task, look for dmSetup
NSTUB( 0xFF0174E0, create_init_task )

/** These are functions missed by the script, copied manually from the original stubs-550d.108.S */
NSTUB( 0xFF0932FC, prop_request_icu_auto_poweroff );
NSTUB( 0x23568, cf_device );
NSTUB( 0x0x23694, sd_device );
NSTUB( 0xFF0642D0, LoadCalendarFromRTC );
NSTUB( 0xFF056064, _audio_ic_write );
NSTUB( 0xFF056EB0, _audio_ic_read );
NSTUB( 0xFFCB48CC, audio_thresholds );
NSTUB( 0x1F04, sounddev );
NSTUB( 0xFF066700, bootdisk_enable );
NSTUB( 0xFF06670C, bootdisk_disable );
NSTUB( 0x27D84, bmp_vram_info );
NSTUB( 0xFF1962A4, FIO_Open );
NSTUB( 0x2D18, dm_names );
NSTUB( 0x1506C, additional_version );

/** These are functions extracted from the IDA database */
NSTUB(0xFF2330B8, AbortEncodeJpeg);                          //!< End address: 0xFF233248; Flags: 0x0 
NSTUB(0xFF110EC8, AllDT);
NSTUB(0xFF027610, AllocateFileCacheItem);                    //!< End address: 0xFF027878; Flags: 0x0 
NSTUB(0xFF3872AC, CFEventHandler);                           //!< End address: 0xFF387980; Flags: 0x0 
NSTUB(0xFF172D64, COL_AbortRectangleColor);                  //!< End address: 0xFF172DEC; Flags: 0x0 
NSTUB(0xFF236AE8, CPY_AbortRectangleCopy);                   //!< End address: 0xFF236B70; Flags: 0x0 
NSTUB(0xFF2363B0, CPY_DummyErrDmac);                         //!< End address: 0xFF2363C0; Flags: 0x0 
NSTUB(0xFF236414, CPY_ReadDmacCompleteCallBack);             //!< End address: 0xFF236468; Flags: 0x0 
NSTUB(0xFF2363C0, CPY_WriteDmacCompleteCallBack);            //!< End address: 0xFF236414; Flags: 0x0 
NSTUB(0xFF22F184, CRP_CancelDecrypto);                       //!< End address: 0xFF22F1DC; Flags: 0x0 
NSTUB(0xFF22EE58, CRP_Decrypto);                             //!< End address: 0xFF22F0BC; Flags: 0x0 
NSTUB(0xFF22F0BC, CRP_DeleteDecrypto);                       //!< End address: 0xFF22F12C; Flags: 0x0 
NSTUB(0xFF22E904, CRP_HashHwWrap_Finish);                    //!< End address: 0xFF22E94C; Flags: 0x0 
NSTUB(0xFF22E85C, CRP_HashHwWrap_Init);                      //!< End address: 0xFF22E898; Flags: 0x0 
NSTUB(0xFF22EB54, CRP_HashSwSha1Wrap_Finish);                //!< End address: 0xFF22EB90; Flags: 0x0 
NSTUB(0xFF22EB10, CRP_HashSwSha1Wrap_Init);                  //!< End address: 0xFF22EB50; Flags: 0x0 
NSTUB(0xFF22EBD8, CRP_HashSwSha256Wrap_Finish);              //!< End address: 0xFF22EC14; Flags: 0x0 
NSTUB(0xFF22EB90, CRP_HashSwSha256Wrap_Init);                //!< End address: 0xFF22EBD0; Flags: 0x0 
NSTUB(0xFF22EA14, CRP_HashSwWrap_Finish);                    //!< End address: 0xFF22EA50; Flags: 0x0 
NSTUB(0xFF22E994, CRP_HashSwWrap_Finish_0);                  //!< End address: 0xFF22E9D0; Flags: 0x0 
NSTUB(0xFF22E9D0, CRP_HashSwWrap_Init);                      //!< End address: 0xFF22EA10; Flags: 0x0 
NSTUB(0xFF22E94C, CRP_HashSwWrap_Init_0);                    //!< End address: 0xFF22E98C; Flags: 0x0 
NSTUB(0xFF22ED14, CRP_InitializeDecryptoTask);               //!< End address: 0xFF22EE00; Flags: 0x0 
NSTUB(0xFF22F12C, CRP_NextDecrypto);                         //!< End address: 0xFF22F184; Flags: 0x0 
NSTUB(0xFF22EE00, CRP_TerminateDecryptoTask);                //!< End address: 0xFF22EE58; Flags: 0x0 
NSTUB(0xFF11065C, CancelDT);
NSTUB(0xFF1710E4, ChangeSrModeLiveViewDevice);               //!< End address: 0xFF171190; Flags: 0x0 
NSTUB(0xFF192DA0, ClockSave);                                //!< End address: 0xFF192E5C; Flags: 0x0 
NSTUB(0xFF110648, CompleteDT);
NSTUB(0xFF17C518, CompressionRateAdjuster);                  //!< End address: 0xFF17C6F8; Flags: 0x0 
NSTUB(0xFF222CF8, CreateObject);                             //!< End address: 0xFF222EC0; Flags: 0x0 
NSTUB(0xFF235894, DEC_AbortDecodeJpeg);                      //!< End address: 0xFF2359C0; Flags: 0x0 
NSTUB(0xFF234C90, DEC_CancelDecodeJpeg);                     //!< End address: 0xFF234FD0; Flags: 0x0 
NSTUB(0xFF234BEC, DEC_DummyCompleteExecutablePass);          //!< End address: 0xFF234C00; Flags: 0x0 
NSTUB(0xFF234C60, DEC_DummyRdDmacCBForSemaphore);            //!< End address: 0xFF234C90; Flags: 0x0 
NSTUB(0xFF234BA8, DEC_DummyStopExecutablePass);              //!< End address: 0xFF234BBC; Flags: 0x0 
NSTUB(0xFF234C30, DEC_DummyWrDmacCBForSemaphore);            //!< End address: 0xFF234C60; Flags: 0x0 
NSTUB(0xFF234C00, DEC_UnregisterCBROfCompleteDecodeJpeg);    //!< End address: 0xFF234C30; Flags: 0x0 
NSTUB(0xFF234BBC, DEC_UnregisterCBROfStopDecodeJpeg);        //!< End address: 0xFF234BEC; Flags: 0x0 
NSTUB(0xFF0CAD34, DPS_GetCapabilityListTerminate);           //!< End address: 0xFF0CAF78; Flags: 0x0 
NSTUB(0xFF031EE0, DP_DeregisterCBR);                         //!< End address: 0xFF031F5C; Flags: 0x0 
NSTUB(0xFF079C0C, DarkCapture);                              //!< End address: 0xFF079CB4; Flags: 0x0 
NSTUB(0xFF066A98, DebugMsg);                                 //!< End address: 0xFF066BCC; Flags: 0x0 
NSTUB(0xFF1E009C, DeleteEvProcInfo);                         //!< End address: 0xFF1E00E8; Flags: 0x0 
NSTUB(0xFF17DD28, DeregisterCBRStallChangeOfControlPipe);    //!< End address: 0xFF17DD74; Flags: 0x0 
NSTUB(0xFF17CE40, DiUSB20CP);                                //!< End address: 0xFF17CE84; Flags: 0x0 
NSTUB(0xFF080498, DisableFaceCatch);                         //!< End address: 0xFF0804A8; Flags: 0x0 
NSTUB(0xFF0804BC, DisableWBDetection);                       //!< End address: 0xFF0804CC; Flags: 0x0 
NSTUB(0xFF215E0C, DoSdioHddBulkOutComplete);                 //!< End address: 0xFF215FE4; Flags: 0x0 
NSTUB(0xFF215AB0, DoSdioHddReceivePTPBulkData);              //!< End address: 0xFF215E0C; Flags: 0x0 
NSTUB(0xFF216484, DoSdioHddSetReceiveDataTotalLength);       //!< End address: 0xFF2164FC; Flags: 0x0 
NSTUB(0xFF216184, DoSdioHddStallBulkTransport);              //!< End address: 0xFF2161C8; Flags: 0x0 
NSTUB(0xFF212780, DoSdioSetReceiveDataTotalLength);          //!< End address: 0xFF2127F8; Flags: 0x0 
NSTUB(0xFF212494, DoSdioStallBulkTransport);                 //!< End address: 0xFF2124D8; Flags: 0x0 
NSTUB(0xFF20FDC4, DoStallBulkTransport);                     //!< End address: 0xFF20FE08; Flags: 0x0 
NSTUB(0xFF2E2218, Do_PTP_GetCapabilityAllListCBR);           //!< End address: 0xFF2E2260; Flags: 0x0 
NSTUB(0xFF2E1804, Do_PTP_NotifyDeviceStateCBR);              //!< End address: 0xFF2E20B4; Flags: 0x0 
NSTUB(0xFF2E107C, Do_PTP_NotifyJobStateCBR);                 //!< End address: 0xFF2E1428; Flags: 0x0 
NSTUB(0xFF2E0EE8, Do_PTP_NotifyPrinterConnectCBR);           //!< End address: 0xFF2E0F5C; Flags: 0x0 
NSTUB(0xFF0CA1F4, DpSetMem_DpGetJobState);                   //!< End address: 0xFF0CA278; Flags: 0x0 
NSTUB(0xFF0BF83C, Dp_ExecuteWaitQueue);                      //!< End address: 0xFF0BFCB8; Flags: 0x0 
NSTUB(0xFF0CA338, Dp_ImageOptimizeCheck);                    //!< End address: 0xFF0CA4F4; Flags: 0x0 
NSTUB(0xFF0C30C8, Dp_InitializeRequest);                     //!< End address: 0xFF0C310C; Flags: 0x0 
NSTUB(0xFF0D48E8, Dp_MemoryStateCBR);                        //!< End address: 0xFF0D4988; Flags: 0x0 
NSTUB(0xFF23307C, DummyCallback);                            //!< End address: 0xFF233090; Flags: 0x0 
NSTUB(0xFF1B5504, EnableDisplay);                            //!< End address: 0xFF1B551C; Flags: 0x0 
NSTUB(0xFF080484, EnableFaceCatch);                          //!< End address: 0xFF080498; Flags: 0x0 
NSTUB(0xFF0804A8, EnableWBDetection);                        //!< End address: 0xFF0804BC; Flags: 0x0 
NSTUB(0xFF22E898, Engine_Hash_append);                       //!< End address: 0xFF22E904; Flags: 0x0 
NSTUB(0xFF1C7A00, ExifAvDataToString);                       //!< End address: 0xFF1C7B08; Flags: 0x0 
NSTUB(0xFF1C7B08, ExifTvDataToString);                       //!< End address: 0xFF1C7C1C; Flags: 0x0 
NSTUB(0xFF1DDD40, FA_AddProperty);                           //!< End address: 0xFF1DDDE0; Flags: 0x0 
NSTUB(0xFF1DF5C4, FA_AdjustWhiteBalance);                    //!< End address: 0xFF1DF624; Flags: 0x0 
NSTUB(0xFF1DFC18, FA_CreateClrAdjustShootingInfo);           //!< End address: 0xFF1DFC78; Flags: 0x0 
NSTUB(0xFF1DE9EC, FA_DefectsTestImage);                      //!< End address: 0xFF1DEA7C; Flags: 0x0 
NSTUB(0xFF1E2BE0, FA_DeleteFile);                            //!< End address: 0xFF1E2C60; Flags: 0x0 
NSTUB(0xFF1DDDE0, FA_DeleteProperty);                        //!< End address: 0xFF1DDE24; Flags: 0x0 
NSTUB(0xFF1DEA7C, FA_DetectDefTestImage);                    //!< End address: 0xFF1DEB34; Flags: 0x0 
NSTUB(0xFF1DF958, FA_EnableColorAdjustMode);                 //!< End address: 0xFF1DF984; Flags: 0x0 
NSTUB(0xFF1DF934, FA_EnableColorTargetMode);                 //!< End address: 0xFF1DF958; Flags: 0x0 
NSTUB(0xFF0FB4C8, FA_GetAfValFepInLv);                       //!< End address: 0xFF0FB4E4; Flags: 0x0 
NSTUB(0xFF0FB490, FA_GetAfValFesInLv);                       //!< End address: 0xFF0FB4AC; Flags: 0x0 
NSTUB(0xFF0FB4E4, FA_GetAfValMmpInLv);                       //!< End address: 0xFF0FB500; Flags: 0x0 
NSTUB(0xFF0FB4AC, FA_GetAfValTepInLv);                       //!< End address: 0xFF0FB4C8; Flags: 0x0 
NSTUB(0xFF0FB474, FA_GetAfValTesInLv);                       //!< End address: 0xFF0FB490; Flags: 0x0 
NSTUB(0xFF0FB604, FA_GetAfValYitgInLv);
NSTUB(0xFF0FB5EC, FA_GetAfValYpInLv);
NSTUB(0xFF1DE688, FA_GetDetectDefCount);                     //!< End address: 0xFF1DE6AC; Flags: 0x0 
NSTUB(0xFF1E2AE8, FA_GetFileData);                           //!< End address: 0xFF1E2BA8; Flags: 0x0 
NSTUB(0xFF1E2924, FA_GetFileSize);                           //!< End address: 0xFF1E297C; Flags: 0x0 
NSTUB(0xFF1DE0D8, FA_GetFreeSizeOfMemory);                   //!< End address: 0xFF1DE180; Flags: 0x0 
NSTUB(0xFF1DEDBC, FA_GetObInteg);                            //!< End address: 0xFF1DEDD8; Flags: 0x0 
NSTUB(0xFF1DEDD8, FA_GetObIntegParam);                       //!< End address: 0xFF1DEE08; Flags: 0x0 
NSTUB(0xFF1DD768, FA_GetProperty);                           //!< End address: 0xFF1DD7AC; Flags: 0x0 
NSTUB(0xFF1DD7AC, FA_GetPropertyAddress);                    //!< End address: 0xFF1DD7FC; Flags: 0x0 
NSTUB(0xFF1DF6D4, FA_GetReverseAdjustSum);                   //!< End address: 0xFF1DF6F0; Flags: 0x0 
NSTUB(0xFF1DF7F8, FA_GetReverseAdjustSum2);                  //!< End address: 0xFF1DF86C; Flags: 0x0 
NSTUB(0xFF0A5DEC, FA_GetSecCheckData);                       //!< End address: 0xFF0A5E1C; Flags: 0x0 
NSTUB(0xFF1DE180, FA_GetTotalSizeOfMemory);                  //!< End address: 0xFF1DE1D4; Flags: 0x0 
NSTUB(0xFF1DF918, FA_GetWbCoef);                             //!< End address: 0xFF1DF934; Flags: 0x0 
NSTUB(0xFF1DF1D8, FA_HShadingGapCheckAllChannel);            //!< End address: 0xFF1DF244; Flags: 0x0 
NSTUB(0xFF1DF244, FA_HShadingGapCheckEitherSide);            //!< End address: 0xFF1DF2B0; Flags: 0x0 
NSTUB(0xFF1DF164, FA_HShadingGapCheckOnChannel);             //!< End address: 0xFF1DF1D8; Flags: 0x0 
NSTUB(0xFF1DDCFC, FA_LoadProperty);                          //!< End address: 0xFF1DDD40; Flags: 0x0 
NSTUB(0xFF16F954, FA_MacSelfCheck);                          //!< End address: 0xFF16FA2C; Flags: 0x0 
NSTUB(0xFF1DE790, FA_MaxSelectTestImage);                    //!< End address: 0xFF1DE870; Flags: 0x0 
NSTUB(0xFF1E28B4, FA_MovieEnd);                              //!< End address: 0xFF1E2924; Flags: 0x0 
NSTUB(0xFF1E280C, FA_MovieStart);                            //!< End address: 0xFF1E28B4; Flags: 0x0 
NSTUB(0xFF1DEB34, FA_ObIntegTestImage);                      //!< End address: 0xFF1DECD4; Flags: 0x0 
NSTUB(0xFF1DEE08, FA_ProjectionTestImage);                   //!< End address: 0xFF1DEF74; Flags: 0x0 
NSTUB(0xFF1DEF74, FA_ProjectionTestImageV);                  //!< End address: 0xFF1DF088; Flags: 0x0 
NSTUB(0xFF1DDA44, FA_RegistSavePropertyList);                //!< End address: 0xFF1DDB48; Flags: 0x0 
NSTUB(0xFF1DF65C, FA_ReverseAdjust);                         //!< End address: 0xFF1DF6D4; Flags: 0x0 
NSTUB(0xFF1DD7FC, FA_SaveProperty);                          //!< End address: 0xFF1DDA0C; Flags: 0x0 
NSTUB(0xFF1DDB48, FA_SavePropertyList);                      //!< End address: 0xFF1DDC04; Flags: 0x0 
NSTUB(0xFF1DF624, FA_SaveWbFix);                             //!< End address: 0xFF1DF65C; Flags: 0x0 
NSTUB(0xFF16FA2C, FA_SecDifficult);                          //!< End address: 0xFF16FF40; Flags: 0x0 
NSTUB(0xFF1DE47C, FA_SetBayerComponent);                     //!< End address: 0xFF1DE4A4; Flags: 0x0 
NSTUB(0xFF1DE350, FA_SetCRawBitNum);                         //!< End address: 0xFF1DE378; Flags: 0x0 
NSTUB(0xFF1DE454, FA_SetChannelNum);                         //!< End address: 0xFF1DE47C; Flags: 0x0 
NSTUB(0xFF1DFB2C, FA_SetColor);                              //!< End address: 0xFF1DFC18; Flags: 0x0 
NSTUB(0xFF1DDEAC, FA_SetDefaultSetting);                     //!< End address: 0xFF1DE0D8; Flags: 0x0 
NSTUB(0xFF1DE630, FA_SetDetectDefThreshold);                 //!< End address: 0xFF1DE688; Flags: 0x0 
NSTUB(0xFF1DE6AC, FA_SetHLinePixelNum);                      //!< End address: 0xFF1DE6D8; Flags: 0x0 
NSTUB(0xFF1DE4A4, FA_SetHProjectionRange);                   //!< End address: 0xFF1DE4E4; Flags: 0x0 
NSTUB(0xFF1DE3F8, FA_SetObIntegMode);                        //!< End address: 0xFF1DE428; Flags: 0x0 
NSTUB(0xFF1DE3A0, FA_SetObWindow);                           //!< End address: 0xFF1DE3F8; Flags: 0x0 
NSTUB(0xFF1DE428, FA_SetProjectionMode);                     //!< End address: 0xFF1DE454; Flags: 0x0 
NSTUB(0xFF1DE5E8, FA_SetProjectionWindow);                   //!< End address: 0xFF1DE630; Flags: 0x0 
NSTUB(0xFF1DD724, FA_SetProperty);                           //!< End address: 0xFF1DD768; Flags: 0x0 
NSTUB(0xFF1DDA0C, FA_SetSavePropertyListNum);                //!< End address: 0xFF1DDA44; Flags: 0x0 
NSTUB(0xFF1DE378, FA_SetShadingProductionValue);             //!< End address: 0xFF1DE3A0; Flags: 0x0 
NSTUB(0xFF1DF86C, FA_SetWbCoef);                             //!< End address: 0xFF1DF918; Flags: 0x0 
NSTUB(0xFF1DE6D8, FA_SubtractTestImage);                     //!< End address: 0xFF1DE790; Flags: 0x0 
NSTUB(0xFF1DDE24, FA_SyncProperty);                          //!< End address: 0xFF1DDE90; Flags: 0x0 
NSTUB(0xFF1DF984, FA_UseAdjustDevelopParam);                 //!< End address: 0xFF1DF9B8; Flags: 0x0 
NSTUB(0xFF1DFC78, FA_UseDefaultDevelopParam);                //!< End address: 0xFF1DFCDC; Flags: 0x0 
NSTUB(0xFF1DFAD4, FA_YuvDevelopTestImage);                   //!< End address: 0xFF1DFB2C; Flags: 0x0 
NSTUB(0xFF196400, FIO_CloseFile);                            //!< End address: 0xFF1964A0; Flags: 0x0 
NSTUB(0xFF196358, FIO_CreateFile);                           //!< End address: 0xFF196400; Flags: 0x0 
NSTUB(0xFF1969F4, FIO_GetFileSize);                          //!< End address: 0xFF196A24; Flags: 0x0 
NSTUB(0xFF196690, FIO_ReadFile);                             //!< End address: 0xFF196740; Flags: 0x0 
NSTUB(0xFF196840, FIO_WriteFile);                            //!< End address: 0xFF1968F0; Flags: 0x0 
NSTUB(0xFF040B70, FM_CancelOperation);                       //!< End address: 0xFF040BF4; Flags: 0x0 
NSTUB(0xFF1BD5F4, FM_SetFileNumberMode);                     //!< End address: 0xFF1BD628; Flags: 0x0 
NSTUB(0xFF224884, FlushImage);                               //!< End address: 0xFF2248C0; Flags: 0x0 
NSTUB(0xFF1BBD10, GUI_GetCR2ImgSize);                        //!< End address: 0xFF1BBD60; Flags: 0x0 
NSTUB(0xFF1C6BD4, GUI_GetCurrentLensName);                   //!< End address: 0xFF1C6C10; Flags: 0x0 
NSTUB(0xFF1C87FC, GUI_GetDriveExist);                        //!< End address: 0xFF1C8834; Flags: 0x0 
NSTUB(0xFF1BC4B0, GUI_GetFileIndexInDrive);                  //!< End address: 0xFF1BC4F8; Flags: 0x0 
NSTUB(0xFF1BBC70, GUI_GetImgFormat);                         //!< End address: 0xFF1BBCC0; Flags: 0x0 
NSTUB(0xFF1BBCC0, GUI_GetImgQuality);                        //!< End address: 0xFF1BBD10; Flags: 0x0 
NSTUB(0xFF1BBD60, GUI_GetJpgImgSize);                        //!< End address: 0xFF1BBDB0; Flags: 0x0 
NSTUB(0xFF1BD0F8, GUI_GetMWBCaption);                        //!< End address: 0xFF1BD178; Flags: 0x0 
NSTUB(0xFF1BC564, GUI_GetMultiPosition);                     //!< End address: 0xFF1BC5BC; Flags: 0x0 
NSTUB(0xFF1C6840, GUI_GetNumOfBatteriesHistory);             //!< End address: 0xFF1C6864; Flags: 0x0 
NSTUB(0xFF1C6878, GUI_GetNumOfBatteriesHistory_0);           //!< End address: 0xFF1C68C8; Flags: 0x0 
NSTUB(0xFF1C04B8, GUI_GetPsUserSetting_PCsetDetail);         //!< End address: 0xFF1C0538; Flags: 0x0 
NSTUB(0xFF1B67E8, GUI_GetVlcChoukouLevel);                   //!< End address: 0xFF1B68E0; Flags: 0x0 
NSTUB(0xFF1B66D8, GUI_GetVlcExposureLevel);                  //!< End address: 0xFF1B67D0; Flags: 0x0 
NSTUB(0xFF1C48C0, GUI_Lan_setTcpipStruct);                   //!< End address: 0xFF1C4960; Flags: 0x0 
NSTUB(0xFF1C4840, GUI_Lan_setTransmissionStruct);            //!< End address: 0xFF1C48C0; Flags: 0x0 
NSTUB(0xFF1C6908, GUI_RefreshBatteriesHistory);              //!< End address: 0xFF1C69FC; Flags: 0x0 
NSTUB(0xFF1BE9B0, GUI_SetASDoneRecord);                      //!< End address: 0xFF1BE9F4; Flags: 0x0 
NSTUB(0xFF1BE910, GUI_SetActiveSweepMode);                   //!< End address: 0xFF1BE948; Flags: 0x0 
NSTUB(0xFF1BE954, GUI_SetActiveSweepStatus);                 //!< End address: 0xFF1BE998; Flags: 0x0 
NSTUB(0xFF1BCA20, GUI_SetAloMode);                           //!< End address: 0xFF1BCA54; Flags: 0x0 
NSTUB(0xFF1BEED4, GUI_SetAudioVolume);                       //!< End address: 0xFF1BEF10; Flags: 0x0 
NSTUB(0xFF1C68C8, GUI_SetBatteriesHistory);                  //!< End address: 0xFF1C6908; Flags: 0x0 
NSTUB(0xFF1BCAA0, GUI_SetBeep);                              //!< End address: 0xFF1BCAD4; Flags: 0x0 
NSTUB(0xFF1BD634, GUI_SetCurentDirDCF);                      //!< End address: 0xFF1BD6B4; Flags: 0x0 
NSTUB(0xFF1BE70C, GUI_SetDateStyle);                         //!< End address: 0xFF1BE744; Flags: 0x0 
NSTUB(0xFF1BE67C, GUI_SetDisplayOffSensor);                  //!< End address: 0xFF1BE6B4; Flags: 0x0 
NSTUB(0xFF1BEA84, GUI_SetElectricShutter);                   //!< End address: 0xFF1BEABC; Flags: 0x0 
NSTUB(0xFF1BC444, GUI_SetFileIndexInDrive);                  //!< End address: 0xFF1BC4B0; Flags: 0x0 
NSTUB(0xFF1BD460, GUI_SetFileNameMode);                      //!< End address: 0xFF1BD4D4; Flags: 0x0 
NSTUB(0xFF1BCD58, GUI_SetFinderGridSelect);                  //!< End address: 0xFF1BCD8C; Flags: 0x0 
NSTUB(0xFF1BCCF4, GUI_SetIlluminCorrect);                    //!< End address: 0xFF1BCD28; Flags: 0x0 
NSTUB(0xFF1BBB8C, GUI_SetImgComposition);                    //!< End address: 0xFF1BBC70; Flags: 0x0 
NSTUB(0xFF1BEA20, GUI_SetInfoButtonShoot);                   //!< End address: 0xFF1BEA78; Flags: 0x0 
NSTUB(0xFF1BC9DC, GUI_SetJpegSsizeCompression);              //!< End address: 0xFF1BCA14; Flags: 0x0 
NSTUB(0xFF1BE638, GUI_SetLCDBrightness_Adjustment);          //!< End address: 0xFF1BE670; Flags: 0x0 
NSTUB(0xFF1BE4D8, GUI_SetLCDBrightness_auto);                //!< End address: 0xFF1BE510; Flags: 0x0 
NSTUB(0xFF1BE494, GUI_SetLCDBrightness_manual);              //!< End address: 0xFF1BE4CC; Flags: 0x0 
NSTUB(0xFF1BE750, GUI_SetLanguage);                          //!< End address: 0xFF1BE788; Flags: 0x0 
NSTUB(0xFF1BEAC8, GUI_SetLiveView);                          //!< End address: 0xFF1BEB04; Flags: 0x0 
NSTUB(0xFF1BECF0, GUI_SetLvAfMode);                          //!< End address: 0xFF1BED2C; Flags: 0x0 
NSTUB(0xFF1BEBD8, GUI_SetLvGrid);                            //!< End address: 0xFF1BEC10; Flags: 0x0 
NSTUB(0xFF1BEC60, GUI_SetLvMode);                            //!< End address: 0xFF1BEC9C; Flags: 0x0 
NSTUB(0xFF1BECA8, GUI_SetLvScreenSet);                       //!< End address: 0xFF1BECE4; Flags: 0x0 
NSTUB(0xFF1BEC1C, GUI_SetLvTimer);                           //!< End address: 0xFF1BEC54; Flags: 0x0 
NSTUB(0xFF1BD030, GUI_SetMWB);                               //!< End address: 0xFF1BD0F8; Flags: 0x0 
NSTUB(0xFF1BEE8C, GUI_SetMovieRemoconShoot);                 //!< End address: 0xFF1BEEC8; Flags: 0x0 
NSTUB(0xFF1BC4F8, GUI_SetMultiPosition);                     //!< End address: 0xFF1BC564; Flags: 0x0 
NSTUB(0xFF1BE794, GUI_SetMwbNumber);                         //!< End address: 0xFF1BE7D0; Flags: 0x0 
NSTUB(0xFF1BCAE0, GUI_SetNoCardRelease);                     //!< End address: 0xFF1BCB14; Flags: 0x0 
NSTUB(0xFF1BE6C0, GUI_SetOlcDispSetting);                    //!< End address: 0xFF1BE700; Flags: 0x0 
NSTUB(0xFF1BBEB8, GUI_SetOneshotRaw);                        //!< End address: 0xFF1BBF0C; Flags: 0x0 
NSTUB(0xFF1BE450, GUI_SetPTP);                               //!< End address: 0xFF1BE488; Flags: 0x0 
NSTUB(0xFF1BE7DC, GUI_SetPcWbNumber);                        //!< End address: 0xFF1BE818; Flags: 0x0 
NSTUB(0xFF1BCA60, GUI_SetRedEyeReduction);                   //!< End address: 0xFF1BCA94; Flags: 0x0 
NSTUB(0xFF1BE3DC, GUI_SetRollingPitchingLevelStatus);        //!< End address: 0xFF1BE410; Flags: 0x0 
NSTUB(0xFF1BEDA4, GUI_SetSoundRec);                          //!< End address: 0xFF1BEDE0; Flags: 0x0 
NSTUB(0xFF1BE074, GUI_SetStroboSettingCompositionStatus);    //!< End address: 0xFF1BE0C4; Flags: 0x0 
NSTUB(0xFF1BD8D4, GUI_SetStroboSettingData);                 //!< End address: 0xFF1BD9CC; Flags: 0x0 
NSTUB(0xFF1BDDA0, GUI_SetStroboWLSettingData);               //!< End address: 0xFF1BDE50; Flags: 0x0 
NSTUB(0xFF0CB00C, GetCapabilityReceiveList);                 //!< End address: 0xFF0CBA80; Flags: 0x0 
NSTUB(0xFF1C7824, GetDigipWbsft);                            //!< End address: 0xFF1C78CC; Flags: 0x0 
NSTUB(0xFF1E0F08, GetEvProcInfoHaveReturnData);              //!< End address: 0xFF1E0F60; Flags: 0x0 
NSTUB(0xFF1E0428, GetEvProcInfoReturnData);                  //!< End address: 0xFF1E0480; Flags: 0x0 
NSTUB(0xFF1E0480, GetEvProcInfoReturnDataSize);              //!< End address: 0xFF1E04D0; Flags: 0x0 
NSTUB(0xFF1E04D0, GetEvProcInfoState);                       //!< End address: 0xFF1E0528; Flags: 0x0 
NSTUB(0xFF1E0528, GetEventProcReturnData);                   //!< End address: 0xFF1E06E0; Flags: 0x0 
NSTUB(0xFF222EC0, GetHandle);                                //!< End address: 0xFF222F9C; Flags: 0x0 
NSTUB(0xFF1C6E28, GetLangName);                              //!< End address: 0xFF1C6E94; Flags: 0x0 
NSTUB(0xFF1BC754, GetMyMenuItemList);                        //!< End address: 0xFF1BC78C; Flags: 0x0 
NSTUB(0xFF1C7EB4, GpsAltitudeDataToString);                  //!< End address: 0xFF1C7F70; Flags: 0x0 
NSTUB(0xFF1C7CA4, GpsLatitudeAngleDataToString);             //!< End address: 0xFF1C7D10; Flags: 0x0 
NSTUB(0xFF1C7D10, GpsLongitudeAngleDataToString);            //!< End address: 0xFF1C7EB4; Flags: 0x0 
NSTUB(0xFF1C7F70, GpsTimeHourToString);                      //!< End address: 0xFF1C7FE8; Flags: 0x0 
NSTUB(0xFF1C7FE8, GpsTimeMinuteToString);                    //!< End address: 0xFF1C81EC; Flags: 0x0 
NSTUB(0xFF1C81EC, GpsTimeSecondToString);                    //!< End address: 0xFF1C830C; Flags: 0x0 
NSTUB(0xFF1B0A7C, GuiGraphicsAllocateMemory);                //!< End address: 0xFF1B0B30; Flags: 0x0 
NSTUB(0xFF1B0C9C, GuiGraphicsFreeMemory);                    //!< End address: 0xFF1B0CF4; Flags: 0x0 
NSTUB(0xFF24ADF8, H264DecDummyCallback);                     //!< End address: 0xFF24AE0C; Flags: 0x0 
NSTUB(0xFF2460F8, H264Dec_DummyCallback);                    //!< End address: 0xFF24610C; Flags: 0x0 
NSTUB(0xFF236230, HST_AbortHistPath);                        //!< End address: 0xFF236290; Flags: 0x0 
NSTUB(0xFF23613C, HST_CancelHistPath);                       //!< End address: 0xFF236204; Flags: 0x0 
NSTUB(0xFF236108, HST_DummyCompleteExecutablePath);          //!< End address: 0xFF236118; Flags: 0x0 
NSTUB(0xFF236204, HST_RegisterCBROfCompleteHistPath);        //!< End address: 0xFF236230; Flags: 0x0 
NSTUB(0xFF236118, HST_UnregisterCBROfCompleteHistPath);      //!< End address: 0xFF23613C; Flags: 0x0 
NSTUB(0xFF244CF4, InitializeH264DecRotatePath);              //!< End address: 0xFF244D44; Flags: 0x0 
NSTUB(0xFF19F428, InitializeIPCMasterTask);                  //!< End address: 0xFF19F594; Flags: 0x0 
NSTUB(0xFF1A0078, InitializeRPC);                            //!< End address: 0xFF1A00E4; Flags: 0x0 
NSTUB(0xFF1E0F60, IsEventProcRunning);                       //!< End address: 0xFF1E117C; Flags: 0x0 
NSTUB(0xFF1C72EC, IsoDataToString);                          //!< End address: 0xFF1C7458; Flags: 0x0 
NSTUB(0xFF233D78, LOT_AbortLotusPath);                       //!< End address: 0xFF233DFC; Flags: 0x0 
NSTUB(0xFF1717A8, LV_ChnageHD);                              //!< End address: 0xFF171814; Flags: 0x0 
NSTUB(0xFF1E0AF0, LoadTransparentMemory);                    //!< End address: 0xFF1E0C54; Flags: 0x0 
NSTUB(0xFF16EA80, MAC_Create);                               //!< End address: 0xFF16EAD8; Flags: 0x0 
NSTUB(0xFF16EAD8, MAC_Delete);                               //!< End address: 0xFF16EB34; Flags: 0x0 
NSTUB(0xFF16EA40, MAC_Finish);                               //!< End address: 0xFF16EA80; Flags: 0x0 
NSTUB(0xFF16E41C, MAC_GetCheckData);                         //!< End address: 0xFF16E5A4; Flags: 0x0 
NSTUB(0xFF16E838, MAC_Initialize);                           //!< End address: 0xFF16E8DC; Flags: 0x0 
NSTUB(0xFF16E9A0, MAC_Start);                                //!< End address: 0xFF16EA40; Flags: 0x0 
NSTUB(0xFF17758C, MjpegDecRotate);                           //!< End address: 0xFF177988; Flags: 0x0 
NSTUB(0xFF110A9C, NotDT);
NSTUB(0xFF244DFC, NotifyAbortRdDmac);                        //!< End address: 0xFF244E10; Flags: 0x0 
NSTUB(0xFF244D44, NotifyAbortWrDmac);                        //!< End address: 0xFF244D58; Flags: 0x0 
NSTUB(0xFF244F1C, NotifyCompleteRdDmac);                     //!< End address: 0xFF245084; Flags: 0x0 
NSTUB(0xFF244D58, NotifyCompleteWrDmac);                     //!< End address: 0xFF244DFC; Flags: 0x0 
NSTUB(0xFF1E15CC, NotifyExecuteEventProc);                   //!< End address: 0xFF1E1730; Flags: 0x0 
NSTUB(0xFF1107D8, NumDT);                                    //!< End address: 0xFF110874; Flags: 0x0 
NSTUB(0xFF1BCB7C, NumberOfEntryLensDataList);                //!< End address: 0xFF1BCCE0; Flags: 0x0 
NSTUB(0xFF213B2C, OperTrns_ReceiveDataLength);               //!< End address: 0xFF213B90; Flags: 0x0 
NSTUB(0xFF1BF6EC, PROP_FLAVOR_MODE);                         //!< End address: 0xFF1BF724; Flags: 0x0 
NSTUB(0xFF0C9C70, PTP_AbortPrintRequest);                    //!< End address: 0xFF0C9F30; Flags: 0x0 
NSTUB(0xFF0C7C9C, PTP_AsyncGetPrinterCapabilityInfoListRe);  //!< End address: 0xFF0C7F54; Flags: 0x0 
NSTUB(0xFF0C9FE8, PTP_GetDeviceStateRequest);                //!< End address: 0xFF0CA018; Flags: 0x0 
NSTUB(0xFF0C9FB8, PTP_GetJobStateRequest);                   //!< End address: 0xFF0C9FE8; Flags: 0x0 
NSTUB(0xFF0C9F30, PTP_ResumePrintRequest);                   //!< End address: 0xFF0C9FB8; Flags: 0x0 
NSTUB(0xFF0C92D4, PTP_StartPrintDpofIndexRequest);           //!< End address: 0xFF0C9738; Flags: 0x0 
NSTUB(0xFF0C9738, PTP_StartPrintDpofStandardRequest);        //!< End address: 0xFF0C9C58; Flags: 0x0 
NSTUB(0xFF0C8DF0, PTP_StartPrintRequest);                    //!< End address: 0xFF0C92D4; Flags: 0x0 
NSTUB(0xFF1E0C54, QuerySizeOfTransparentMemory);             //!< End address: 0xFF1E0EB8; Flags: 0x0 
NSTUB(0xFF19FB64, QuickOutIPCTransfer);                      //!< End address: 0xFF19FC34; Flags: 0x0 
NSTUB(0xFF238FD0, RSZ_AbortResizeYuv);                       //!< End address: 0xFF23906C; Flags: 0x0 
NSTUB(0xFF238F98, RSZ_DummyCompleteExecutablePath);          //!< End address: 0xFF238FAC; Flags: 0x0 
NSTUB(0xFF23906C, RSZ_ReleasePathResources);                 //!< End address: 0xFF2390A4; Flags: 0x0 
NSTUB(0xFF238FAC, RSZ_UnregisterCBROfCompleteResizeYuv);     //!< End address: 0xFF238FD0; Flags: 0x0 
NSTUB(0xFF19800C, RcvRSPC);                                  //!< End address: 0xFF1980CC; Flags: 0x0 
NSTUB(0xFF18F744, ReadDMACInterrupt);                        //!< End address: 0xFF18F8A4; Flags: 0x0 
NSTUB(0xFF1705D4, ReadyLiveViewDevice);                      //!< End address: 0xFF170764; Flags: 0x0 
NSTUB(0xFF197DD4, ReceiveResponse);                          //!< End address: 0xFF197E7C; Flags: 0x0 
NSTUB(0xFF28F78C, RegisterEDmacCompleteCBRForMemorySuite);   //!< End address: 0xFF28F7D0; Flags: 0x0 
NSTUB(0xFF1A00E4, RegisterRPCHandler);                       //!< End address: 0xFF1A0194; Flags: 0x0 
NSTUB(0xFF22470C, RemoveObject);                             //!< End address: 0xFF224884; Flags: 0x0 
NSTUB(0xFF11004C, ReqCancelDT);
NSTUB(0xFF110CA4, ReqDT);                                    //!< End address: 0xFF110D0C; Flags: 0x0 
NSTUB(0xFF1A0194, RequestRPC);                               //!< End address: 0xFF1A0260; Flags: 0x0 
NSTUB(0xFF239A7C, RequestRotationYuv);                       //!< End address: 0xFF239B04; Flags: 0x0 
NSTUB(0xFF14C274, RequestWrite);                             //!< End address: 0xFF14C400; Flags: 0x0 
NSTUB(0xFF393C90, SDEventHandler);                           //!< End address: 0xFF394278; Flags: 0x0 
NSTUB(0xFF2FD9B0, SRD2_DummyCallback);                       //!< End address: 0xFF2FD9C0; Flags: 0x0 
NSTUB(0xFF187F14, SaveMultiPropertyPartly);                  //!< End address: 0xFF187F64; Flags: 0x0 
NSTUB(0xFF187E88, SaveProperty);                             //!< End address: 0xFF187EC8; Flags: 0x0 
NSTUB(0xFF187EC8, SavePropertyPartly);                       //!< End address: 0xFF187F14; Flags: 0x0 
NSTUB(0xFF1E07CC, SaveTransparentMemory);                    //!< End address: 0xFF1E0AF0; Flags: 0x0 
NSTUB(0xFF212FF8, SdioSendPTPResponderData);                 //!< End address: 0xFF2134A8; Flags: 0x0 
NSTUB(0xFF110BF8, SelectDT);
NSTUB(0xFF197E7C, SendGetStatusCommand);                     //!< End address: 0xFF197F18; Flags: 0x0 
NSTUB(0xFF1E00E8, SendPTPResponse);                          //!< End address: 0xFF1E0124; Flags: 0x0 
NSTUB(0xFF2126A8, SendResponsePhase);                        //!< End address: 0xFF21271C; Flags: 0x0 
NSTUB(0xFF061718, SetBacklightBrightness);                   //!< End address: 0xFF0617E8; Flags: 0x0 
NSTUB(0xFF171264, SetBeforeModeChageLiveViewDevice);         //!< End address: 0xFF1712B4; Flags: 0x0 
NSTUB(0xFF1E157C, SetEvProcInfoHaveReturnData);              //!< End address: 0xFF1E15CC; Flags: 0x0 
NSTUB(0xFF1E0EB8, SetEvProcInfoState);                       //!< End address: 0xFF1E0F08; Flags: 0x0 
NSTUB(0xFF1C830C, SetMoviePlayTimeDataToWinSystem);          //!< End address: 0xFF1C83CC; Flags: 0x0 
NSTUB(0xFF053E08, SetNextINT16ASIFADCBuffer);                //!< End address: 0xFF053E34; Flags: 0x0 
NSTUB(0xFF053EC0, SetNextINT16ASIFDACBuffer);                //!< End address: 0xFF053EEC; Flags: 0x0 
NSTUB(0xFF053DDC, SetNextUINT8ASIFADCBuffer);                //!< End address: 0xFF053E08; Flags: 0x0 
NSTUB(0xFF053E94, SetNextUINT8ASIFDACBuffer);                //!< End address: 0xFF053EC0; Flags: 0x0 
NSTUB(0xFF1B5198, SnatchUSB);                                //!< End address: 0xFF1B539C; Flags: 0x0 
NSTUB(0xFF053CFC, StartASIFforObserve);                      //!< End address: 0xFF053D44; Flags: 0x0 
NSTUB(0xFF14BC5C, StartWriter);                              //!< End address: 0xFF14BF30; Flags: 0x0 
NSTUB(0xFF170CC4, StartupLiveViewDevice);                    //!< End address: 0xFF170E18; Flags: 0x0 
NSTUB(0xFF1E230C, StartupPTPtoFAPI);                         //!< End address: 0xFF1E23FC; Flags: 0x0 
NSTUB(0xFF053D44, StopASIFforObserve);                       //!< End address: 0xFF053D7C; Flags: 0x0 
NSTUB(0xFF3D5498, StopDpEffectColorBalanceApp);              //!< End address: 0xFF3D54D4; Flags: 0x0 
NSTUB(0xFF14F6F4, StopWriter);                               //!< End address: 0xFF14F9CC; Flags: 0x0 
NSTUB(0xFF171008, TG_ResetPsave);                            //!< End address: 0xFF1710BC; Flags: 0x0 
NSTUB(0xFF2439FC, TWIN_StopDecWinPath);                      //!< End address: 0xFF243A54; Flags: 0x0 
NSTUB(0xFF1B5128, TestALL);                                  //!< End address: 0xFF1B5144; Flags: 0x0 
NSTUB(0xFF248C14, ThbDec_DummyCallback);                     //!< End address: 0xFF248C28; Flags: 0x0 
NSTUB(0xFF249158, ThbRes_DummyCallback);                     //!< End address: 0xFF24916C; Flags: 0x0 
NSTUB(0xFF17CB9C, USBDriverSuspend);                         //!< End address: 0xFF17CBB8; Flags: 0x0 
NSTUB(0xFF17CC00, USBHPTimer);                               //!< End address: 0xFF17CC58; Flags: 0x0 
NSTUB(0xFF1C753C, WbBracketDataToString);                    //!< End address: 0xFF1C7644; Flags: 0x0 
NSTUB(0xFF1C7748, WbShiftDataToString);                      //!< End address: 0xFF1C7824; Flags: 0x0 
NSTUB(0xFF18F518, WriteDMACInterrupt);                       //!< End address: 0xFF18F700; Flags: 0x0 
NSTUB(0xFF06F528, WriteGangFile);                            //!< End address: 0xFF06F6E4; Flags: 0x0 
NSTUB(0xFF2242FC, WriteObject);                              //!< End address: 0xFF224654; Flags: 0x0 
NSTUB(0xFF22F280, aes_key1);                                 //!< End address: 0xFF22F2EC; Flags: 0x0 
NSTUB(0xFF1A7204, alloc_dma_memory);                         //!< End address: 0xFF1A7238; Flags: 0x0 
NSTUB(0xFF067828, call);                                     //!< End address: 0xFF067878; Flags: 0x0 
NSTUB(0xFF1EB34C, capability);                               //!< End address: 0xFF1EB490; Flags: 0x0 
NSTUB(0xFF123F38, ceresCloseFileValue);                      //!< End address: 0xFF123FEC; Flags: 0x0 
NSTUB(0xFF1241D0, ceresCreateFileValue);                     //!< End address: 0xFF124288; Flags: 0x0 
NSTUB(0xFF123E88, ceresGetWriteObject);                      //!< End address: 0xFF123F38; Flags: 0x0 
NSTUB(0xFF124288, ceresOpenFileValue);                       //!< End address: 0xFF124340; Flags: 0x0 
NSTUB(0xFF123FEC, ceresRemoveFileValue);                     //!< End address: 0xFF1240A0; Flags: 0x0 
NSTUB(0xFF121BC4, ceresSendFactoryProperty);                 //!< End address: 0xFF121C90; Flags: 0x0 
NSTUB(0xFF1223CC, ceresSendGpsInfo);                         //!< End address: 0xFF12246C; Flags: 0x0 
NSTUB(0xFF122114, ceresSetWftProfile);                       //!< End address: 0xFF122324; Flags: 0x0 
NSTUB(0xFF06F708, checksum);                                 //!< End address: 0xFF06F714; Flags: 0x0 
NSTUB(0xFF078374, cmpString);                                //!< End address: 0xFF0783B8; Flags: 0x0 
NSTUB(0xFF28B5D0, compute_chksum);                           //!< End address: 0xFF28B5F4; Flags: 0x0 
NSTUB(0xFF076988, cond);                                     //!< End address: 0xFF076AEC; Flags: 0x0 
NSTUB(0xFF1B6A54, copyDataToStorage);                        //!< End address: 0xFF1BB65C; Flags: 0x0 
NSTUB(0xFF1F67C8, create_LV_movie_log);                      //!< End address: 0xFF1F6820; Flags: 0x0 
NSTUB(0xFF069770, create_named_semaphore);                   //!< End address: 0xFF0697CC; Flags: 0x0 
NSTUB(0xFF2F6154, crpDecCancelForDecrypto);                  //!< End address: 0xFF2F619C; Flags: 0x0 
NSTUB(0xFF2F5ACC, crpDecDecrypto);                           //!< End address: 0xFF2F5CF0; Flags: 0x0 
NSTUB(0xFF2F619C, crpDecDeleteForDecrypto);                  //!< End address: 0xFF2F61F8; Flags: 0x0 
NSTUB(0xFF2F5A54, crpDecInitialized);                        //!< End address: 0xFF2F5ACC; Flags: 0x0 
NSTUB(0xFF2F5CF0, crpDecNextDecrypto);                       //!< End address: 0xFF2F6154; Flags: 0x0 
NSTUB(0xFF2F59F8, crpSlaveChangeCBR);                        //!< End address: 0xFF2F5A54; Flags: 0x0 
NSTUB(0xFF267590, ctrlman_dispatch_event);                   //!< End address: 0xFF267604; Flags: 0x0 
NSTUB(0xFF325090, decipher);                                 //!< End address: 0xFF325108; Flags: 0x0 
NSTUB(0xFF28B00C, decipher_upd);                             //!< End address: 0xFF28B080; Flags: 0x0 
NSTUB(0xFF28B080, decipher_updaters);                        //!< End address: 0xFF28B0DC; Flags: 0x0 
NSTUB(0xFF28B364, decrypt2);                                 //!< End address: 0xFF28B578; Flags: 0x0 
NSTUB(0xFF28B578, decrypt_firmware);                         //!< End address: 0xFF28B5D0; Flags: 0x0 
NSTUB(0xFF198EE0, dispcheck);                                //!< End address: 0xFF198F20; Flags: 0x0 
NSTUB(0xFF19EA74, dmStart);                                  //!< End address: 0xFF19EA98; Flags: 0x0 
NSTUB(0xFF19EA98, dmStop);                                   //!< End address: 0xFF19EABC; Flags: 0x0 
NSTUB(0xFF066D7C, dm_set_store_level);                       //!< End address: 0xFF066DE4; Flags: 0x0 
NSTUB(0xFF067118, dmhistory);                                //!< End address: 0xFF06715C; Flags: 0x0 
NSTUB(0xFF0671E4, dmprint);                                  //!< End address: 0xFF06723C; Flags: 0x0 
NSTUB(0xFF066A18, dmstart);                                  //!< End address: 0xFF066A58; Flags: 0x0 
NSTUB(0xFF066A58, dmstop);                                   //!< End address: 0xFF066A98; Flags: 0x0 
NSTUB(0xFF06718C, dmstore);                                  //!< End address: 0xFF0671E4; Flags: 0x0 
NSTUB(0xFF28B308, do_rand_sha_aes);                          //!< End address: 0xFF28B364; Flags: 0x0 
NSTUB(0xFF2F4788, do_sha_process);                           //!< End address: 0xFF2F482C; Flags: 0x0 
NSTUB(0xFF011E34, dry_shell);                                //!< End address: 0xFF011EB0; Flags: 0x0 
NSTUB(0xFF06735C, dump);                                     //!< End address: 0xFF06738C; Flags: 0x0 
NSTUB(0xFF06732C, dumpf);                                    //!< End address: 0xFF06735C; Flags: 0x0 
NSTUB(0xFF0A66F8, emAutoPowerOff);                           //!< End address: 0xFF0A67DC; Flags: 0x0 
NSTUB(0xFF0A5F88, emDeliverMulticastEvent);                  //!< End address: 0xFF0A6260; Flags: 0x0 
NSTUB(0xFF0A6260, emLockControl);                            //!< End address: 0xFF0A65E8; Flags: 0x0 
NSTUB(0xFF0A5E64, emRegisterMulticastCallback);              //!< End address: 0xFF0A5F20; Flags: 0x0 
NSTUB(0xFF0A5F20, emUnregisterMulticastCallback);            //!< End address: 0xFF0A5F88; Flags: 0x0 
NSTUB(0xFF075CA0, event);                                    //!< End address: 0xFF075CA8; Flags: 0x0 
NSTUB(0xFF01172C, extask);                                   //!< End address: 0xFF011B50; Flags: 0x0 
NSTUB(0xFF1E0134, faSendStreamMemSuiteDataEx);               //!< End address: 0xFF1E0350; Flags: 0x0 
NSTUB(0xFF06F72C, flasherase);                               //!< End address: 0xFF06F82C; Flags: 0x0 
NSTUB(0xFF06F82C, flashwrite);                               //!< End address: 0xFF06FAA4; Flags: 0x0 
NSTUB(0xFF12DD48, fmCreateContainerFile);                    //!< End address: 0xFF12DD7C; Flags: 0x0 
NSTUB(0xFF136FE0, fmReadCR2APP1SizeFromFile);                //!< End address: 0xFF137018; Flags: 0x0 
NSTUB(0xFF1375E4, fmReadCR2DevParamFromMemory);              //!< End address: 0xFF137FD0; Flags: 0x0 
NSTUB(0xFF136690, fmReadCR2FromFile);                        //!< End address: 0xFF136D20; Flags: 0x0 
NSTUB(0xFF137050, fmReadCR2HeaderSizeFromFile);              //!< End address: 0xFF137148; Flags: 0x0 
NSTUB(0xFF137018, fmReadCR2IFDAllSizeFromFile);              //!< End address: 0xFF137050; Flags: 0x0 
NSTUB(0xFF136D20, fmReadCR2OrientationOffsetFromFile);       //!< End address: 0xFF136DF0; Flags: 0x0 
NSTUB(0xFF136DF0, fmReadCR2UserCommentOffsetFromFile);       //!< End address: 0xFF136EA8; Flags: 0x0 
NSTUB(0xFF134AF0, fmReadDCFFromFile);                        //!< End address: 0xFF1350E8; Flags: 0x0 
NSTUB(0xFF13574C, fmReadDCFFromMemory);                      //!< End address: 0xFF135D6C; Flags: 0x0 
NSTUB(0xFF135424, fmReadDCFMovieDescOffsetFromFile);         //!< End address: 0xFF1356C0; Flags: 0x0 
NSTUB(0xFF13511C, fmReadDCFOrientationOffsetFromFile);       //!< End address: 0xFF135224; Flags: 0x0 
NSTUB(0xFF135224, fmReadDCFUserCommentOffsetFromFile);       //!< End address: 0xFF135424; Flags: 0x0 
NSTUB(0xFF138EC8, fmcCompleteCreateJob);                     //!< End address: 0xFF138F30; Flags: 0x0 
NSTUB(0xFF138C44, fmcCompleteCreateJobUnit);                 //!< End address: 0xFF138DA0; Flags: 0x0 
NSTUB(0xFF139310, fmcGetNewFileDcfNo);                       //!< End address: 0xFF13942C; Flags: 0x0 
NSTUB(0xFF13942C, fmcGetNewFileDcfNoIfRemoved);              //!< End address: 0xFF13960C; Flags: 0x0 
NSTUB(0xFF138410, fmcNotifyCreateJob);                       //!< End address: 0xFF138810; Flags: 0x0 
NSTUB(0xFF1380A8, fmcNotifyCreateJobStart);                  //!< End address: 0xFF1382B4; Flags: 0x0 
NSTUB(0xFF139A70, fmcProtectCreateJobUnit);                  //!< End address: 0xFF139AE4; Flags: 0x0 
NSTUB(0xFF13985C, fmcRemoveAllCreateJob);                    //!< End address: 0xFF139A70; Flags: 0x0 
NSTUB(0xFF139794, fmcRemoveCreateJobUnit);                   //!< End address: 0xFF13985C; Flags: 0x0 
NSTUB(0xFF138F64, fmcSearchNotRemovedCreateJobUnit);         //!< End address: 0xFF138FDC; Flags: 0x0 
NSTUB(0xFF138898, fmcStartCreateJob);                        //!< End address: 0xFF138C44; Flags: 0x0 
NSTUB(0xFF1A7238, free_dma_memory);                          //!< End address: 0xFF1A724C; Flags: 0x0 
NSTUB(0xFF228C84, fwActivate);                               //!< End address: 0xFF228D2C; Flags: 0x0 
NSTUB(0xFF228BE4, fwCompleteJob);                            //!< End address: 0xFF228C84; Flags: 0x0 
NSTUB(0xFF228390, fwExecJob);                                //!< End address: 0xFF228BE4; Flags: 0x0 
NSTUB(0xFF228D2C, fwInactivate);                             //!< End address: 0xFF228D70; Flags: 0x0 
NSTUB(0xFF22830C, fwPostJob);                                //!< End address: 0xFF228390; Flags: 0x0 
NSTUB(0xFF1C2830, getAdpProxyAddrAndName);                   //!< End address: 0xFF1C28BC; Flags: 0x0 
NSTUB(0xFF1C2630, getAdpProxyServerSetting);                 //!< End address: 0xFF1C2668; Flags: 0x0 
NSTUB(0xFF0699B8, give_semaphore);                           //!< End address: 0xFF0699F4; Flags: 0x0 
NSTUB(0xFF0672E4, grep);                                     //!< End address: 0xFF06732C; Flags: 0x0 
NSTUB(0xFF1C8874, guiDispSensorStart);                       //!< End address: 0xFF1C889C; Flags: 0x0 
NSTUB(0xFF1C889C, guiDispSensorStop);                        //!< End address: 0xFF1C88C4; Flags: 0x0 
NSTUB(0xFF09186C, gui_change_lcd_state_post);                //!< End address: 0xFF0919E0; Flags: 0x0 
NSTUB(0xFF090C4C, gui_change_mode);                          //!< End address: 0xFF091114; Flags: 0x0 
NSTUB(0xFF0917D4, gui_change_shoot_type_post);               //!< End address: 0xFF09186C; Flags: 0x0 
NSTUB(0xFF023450, gui_init_end);                             //!< End address: 0xFF0234B4; Flags: 0x0 
NSTUB(0xFF091E9C, gui_init_event);                           //!< End address: 0xFF092394; Flags: 0x0 
NSTUB(0xFF091114, gui_local_post);                           //!< End address: 0xFF0914F0; Flags: 0x0 
NSTUB(0xFF11E058, gui_lock);                                 //!< End address: 0xFF11E064; Flags: 0x0 
NSTUB(0xFF022A9C, gui_main_task);                            //!< End address: 0xFF022D14; Flags: 0x1 
NSTUB(0xFF08F638, gui_massive_event_loop);                   //!< End address: 0xFF090B4C; Flags: 0x0 
NSTUB(0xFF0915F0, gui_other_post);                           //!< End address: 0xFF091720; Flags: 0x0 
NSTUB(0xFF091720, gui_post_10000085);                        //!< End address: 0xFF0917D4; Flags: 0x0 
NSTUB(0xFF2676E0, gui_task_create);                          //!< End address: 0xFF267784; Flags: 0x0 
NSTUB(0xFF267800, gui_task_destroy);                         //!< End address: 0xFF267900; Flags: 0x0 
NSTUB(0xFF1A0918, gui_timer_something);                      //!< End address: 0xFF1A094C; Flags: 0x0 
NSTUB(0xFF245268, h264dec);                                  //!< End address: 0xFF245918; Flags: 0x0 
NSTUB(0xFF06FBDC, harbIntISR);                               //!< End address: 0xFF06FC1C; Flags: 0x0 
NSTUB(0xFF22E620, hmac2);                                    //!< End address: 0xFF22E6E0; Flags: 0x0 
NSTUB(0xFF22E6E0, hmac3);                                    //!< End address: 0xFF22E804; Flags: 0x0 
NSTUB(0xFF01DCCC, hotplug_task);                             //!< End address: 0xFF01DE5C; Flags: 0x1 
NSTUB(0xFF244A28, imp_cyuv_LockEngineResources);
NSTUB(0xFF244BE0, imp_cyuv_ReleasePathResources);            //!< End address: 0xFF244C1C; Flags: 0x0 
NSTUB(0xFF0784D8, initRand);                                 //!< End address: 0xFF0784E4; Flags: 0x0 
NSTUB(0xFF2F4BAC, init_sha256);                              //!< End address: 0xFF2F4C18; Flags: 0x0 
NSTUB(0xFF2F6978, init_sha256_related);                      //!< End address: 0xFF2F69C4; Flags: 0x0 
NSTUB(0xFF22E804, init_sha256_related2);                     //!< End address: 0xFF22E830; Flags: 0x0 
NSTUB(0xFF1B4984, ipb);                                      //!< End address: 0xFF1B4A60; Flags: 0x0 
NSTUB(0xFF1A0478, ipcCompleteCBR);                           //!< End address: 0xFF1A049C; Flags: 0x0 
NSTUB(0xFF19F378, ipcEventDispatch);                         //!< End address: 0xFF19F3E0; Flags: 0x0 
NSTUB(0xFF19F1D4, ipcEventHandler);                          //!< End address: 0xFF19F378; Flags: 0x0 
NSTUB(0xFF2946B8, ipcEventProc);                             //!< End address: 0xFF29472C; Flags: 0x0 
NSTUB(0xFF1A049C, ipcForEMI);                                //!< End address: 0xFF1A0558; Flags: 0x0 
NSTUB(0xFF294A5C, ipcmBltDone);                              //!< End address: 0xFF294BE4; Flags: 0x0 
NSTUB(0xFF2947AC, ipcmControl);                              //!< End address: 0xFF29480C; Flags: 0x0 
NSTUB(0xFF29480C, ipcmControlInBulk);                        //!< End address: 0xFF29486C; Flags: 0x0 
NSTUB(0xFF2948A4, ipcmQueueBulk);                            //!< End address: 0xFF2948E4; Flags: 0x0 
NSTUB(0xFF294A1C, ipcmQueueQuick);                           //!< End address: 0xFF294A5C; Flags: 0x0 
NSTUB(0xFF294BE4, ipcmResponse);                             //!< End address: 0xFF294D4C; Flags: 0x0 
NSTUB(0xFF19F594, ipcmSetBaseAddress);                       //!< End address: 0xFF19F5E4; Flags: 0x0 
NSTUB(0xFF294FE0, ipcsComplete);                             //!< End address: 0xFF295068; Flags: 0x0 
NSTUB(0xFF294E8C, ipcsControl);                              //!< End address: 0xFF294EEC; Flags: 0x0 
NSTUB(0xFF294EEC, ipcsPostBulk);                             //!< End address: 0xFF294F28; Flags: 0x0 
NSTUB(0xFF294F28, ipcsPostQuick);                            //!< End address: 0xFF294F64; Flags: 0x0 
NSTUB(0xFF294F64, ipcsRequest);                              //!< End address: 0xFF294FE0; Flags: 0x0 
NSTUB(0xFF2EFB14, j_FIO_ReadFile);                           //!< End address: 0xFF2EFB18; Flags: 0xC0 
NSTUB(0xFF2EFB64, j_alloc_dma_memory);                       //!< End address: 0xFF2EFB68; Flags: 0xC0 
NSTUB(0xFF325108, j_decipher);                               //!< End address: 0xFF32510C; Flags: 0x80 
NSTUB(0xFF268478, j_give_semaphore);                         //!< End address: 0xFF26847C; Flags: 0xC0 
NSTUB(0xFF0DD048, j_give_semaphore_0);                       //!< End address: 0xFF0DD04C; Flags: 0xC0 
NSTUB(0xFF1D2404, j_readEXIFTag);                            //!< End address: 0xFF1D2408; Flags: 0xC0 
NSTUB(0xFF28FE6C, j_strcpy);                                 //!< End address: 0xFF28FE70; Flags: 0xC0 
NSTUB(0xFF31E6F8, j_strcpy_0);                               //!< End address: 0xFF31E6FC; Flags: 0xC0 
NSTUB(0xFF1EB984, jobConfig);                                //!< End address: 0xFF1EBDA0; Flags: 0x0 
NSTUB(0xFF2F64F4, keytransform);                             //!< End address: 0xFF2F674C; Flags: 0x0 
NSTUB(0xFF01A608, kill);                                     //!< End address: 0xFF01A630; Flags: 0x0 
NSTUB(0xFF18F460, load_update);                              //!< End address: 0xFF18F4D0; Flags: 0x0 
NSTUB(0xFF06715C, logstat);                                  //!< End address: 0xFF06718C; Flags: 0x0 
NSTUB(0xFF1F6274, lvaEnd);                                   //!< End address: 0xFF1F62AC; Flags: 0x0 
NSTUB(0xFF1F62AC, lvaEnd2);                                  //!< End address: 0xFF1F62E4; Flags: 0x0 
NSTUB(0xFF1F62E4, lvaSetParam);                              //!< End address: 0xFF1F63BC; Flags: 0x0 
NSTUB(0xFF1F616C, lvaStart);                                 //!< End address: 0xFF1F6274; Flags: 0x0 
NSTUB(0xFF0EB088, lvcaeActivate);                            //!< End address: 0xFF0EB114; Flags: 0x0 
NSTUB(0xFF0EB150, lvcaeCalcAe);                              //!< End address: 0xFF0EB18C; Flags: 0x0 
NSTUB(0xFF0EB18C, lvcaeCalcWb);                              //!< End address: 0xFF0EB304; Flags: 0x0 
NSTUB(0xFF0EB418, lvcaeClearWbCounter);                      //!< End address: 0xFF0EB454; Flags: 0x0 
NSTUB(0xFF0EB550, lvcaeExit);                                //!< End address: 0xFF0EB5A8; Flags: 0x0 
NSTUB(0xFF0EB62C, lvcaeIgnore);                              //!< End address: 0xFF0EB660; Flags: 0x0 
NSTUB(0xFF0EAF38, lvcaeInit);                                //!< End address: 0xFF0EAF7C; Flags: 0x0 
NSTUB(0xFF0EB388, lvcaeLensInfo);                            //!< End address: 0xFF0EB418; Flags: 0x0 
NSTUB(0xFF0EB490, lvcaeProperty);                            //!< End address: 0xFF0EB550; Flags: 0x0 
NSTUB(0xFF0EB114, lvcaeStart);                               //!< End address: 0xFF0EB150; Flags: 0x0 
NSTUB(0xFF0EB454, lvcaeStop);                                //!< End address: 0xFF0EB490; Flags: 0x0 
NSTUB(0xFF0EB74C, lvcafInit);                                //!< End address: 0xFF0EB7DC; Flags: 0x0 
NSTUB(0xFF0EB6B0, lvcafSetCurrentApature);                   //!< End address: 0xFF0EB6DC; Flags: 0x0 
NSTUB(0xFF0ECE78, lvcdevExit);                               //!< End address: 0xFF0ECED0; Flags: 0x0 
NSTUB(0xFF0ECE14, lvcdevFlickerComplete);                    //!< End address: 0xFF0ECE78; Flags: 0x0 
NSTUB(0xFF0EC5B4, lvcdevInit);                               //!< End address: 0xFF0EC638; Flags: 0x0 
NSTUB(0xFF0ECAF0, lvcdevProperty);                           //!< End address: 0xFF0ECB38; Flags: 0x0 
NSTUB(0xFF0ECED0, lvcdevRegisterCBR);                        //!< End address: 0xFF0ECF14; Flags: 0x0 
NSTUB(0xFF0EC86C, lvcdevResourceGet);                        //!< End address: 0xFF0ECA48; Flags: 0x0 
NSTUB(0xFF0ECB38, lvcdevSetFlickerTable);                    //!< End address: 0xFF0ECB78; Flags: 0x0 
NSTUB(0xFF0EC7F4, lvcdevStartDev);                           //!< End address: 0xFF0EC83C; Flags: 0x0 
NSTUB(0xFF0ECF14, lvcdevUnRegisterCBR);                      //!< End address: 0xFF0ECF58; Flags: 0x0 
NSTUB(0xFF06EF98, m_pfAllocMovPlayWorkCBR);                  //!< End address: 0xFF06EFDC; Flags: 0x0 
NSTUB(0xFF06EF10, m_pfAllocMovRecWorkCBR);                   //!< End address: 0xFF06EF54; Flags: 0x0 
NSTUB(0xFF06EF54, m_pfAllocMovStreamCBR);                    //!< End address: 0xFF06EF98; Flags: 0x0 
NSTUB(0xFF06F208, m_pfAllocStorageCBR);                      //!< End address: 0xFF06F254; Flags: 0x0 
NSTUB(0xFF06F254, m_pfDecideSizeCBR);                        //!< End address: 0xFF06F290; Flags: 0x0 
NSTUB(0xFF06EFDC, m_pfFreeMemoryCBR);                        //!< End address: 0xFF06F020; Flags: 0x0 
NSTUB(0xFF06F064, m_pfFreeMovPlayWorkCBR);                   //!< End address: 0xFF06F0A8; Flags: 0x0 
NSTUB(0xFF06F020, m_pfFreeMovRecWorkCBR);                    //!< End address: 0xFF06F064; Flags: 0x0 
NSTUB(0xFF06F178, m_pfFreeMovStreamCBR);                     //!< End address: 0xFF06F1BC; Flags: 0x0 
NSTUB(0xFF06F1BC, m_pfShrinkMemoryCBR);                      //!< End address: 0xFF06F208; Flags: 0x0 
NSTUB(0xFF16ED7C, macGetRealAddr);                           //!< End address: 0xFF16EE10; Flags: 0x0 
NSTUB(0xFF16EB34, macSetArea);                               //!< End address: 0xFF16EC5C; Flags: 0x0 
NSTUB(0xFF3AF8BC, main_s);                                   //!< End address: 0xFF3AFBDC; Flags: 0x0 
NSTUB(0xFF010480, memMap);                                   //!< End address: 0xFF0104A0; Flags: 0x0 
NSTUB(0xFF06F484, memShow);                                  //!< End address: 0xFF06F528; Flags: 0x0 
NSTUB(0xFF3EBB30, memcpy);                                   //!< End address: 0xFF3EBB9C; Flags: 0x0 
NSTUB(0xFF029944, memdump);                                  //!< End address: 0xFF0299E4; Flags: 0x0 
NSTUB(0xFF01B0D4, meminfo);                                  //!< End address: 0xFF01B230; Flags: 0x0 
NSTUB(0xFF011208, memmap);                                   //!< End address: 0xFF011468; Flags: 0x0 
NSTUB(0xFF0771FC, mkobjsize);                                //!< End address: 0xFF077288; Flags: 0x0 
NSTUB(0xFF076364, mq);
NSTUB(0xFF0694D0, msg_queue_receive);                        //!< End address: 0xFF069588; Flags: 0x0 
NSTUB(0xFF069D74, msleep);                                   //!< End address: 0xFF069DC0; Flags: 0x0 
NSTUB(0xFF076554, mutex);                                    //!< End address: 0xFF07685C; Flags: 0x0 
NSTUB(0xFF150020, mvrAllocateStorageCBR);                    //!< End address: 0xFF150060; Flags: 0x0 
NSTUB(0xFF152564, mvrCheckFileSize);                         //!< End address: 0xFF1525B0; Flags: 0x0 
NSTUB(0xFF15089C, mvrCreateThumbnail);                       //!< End address: 0xFF150F18; Flags: 0x0 
NSTUB(0xFF1525B0, mvrDecideAndAddStorageCBR);                //!< End address: 0xFF152618; Flags: 0x0 
NSTUB(0xFF152208, mvrEncode);                                //!< End address: 0xFF152424; Flags: 0x0 
NSTUB(0xFF1521B4, mvrEncodeCBR);                             //!< End address: 0xFF152208; Flags: 0x0 
NSTUB(0xFF152BB4, mvrEncodeDone);                            //!< End address: 0xFF152E64; Flags: 0x0 
NSTUB(0xFF152F6C, mvrEncodeLast);                            //!< End address: 0xFF1530CC; Flags: 0x0 
NSTUB(0xFF153254, mvrEncodeWait);                            //!< End address: 0xFF1532A0; Flags: 0x0 
NSTUB(0xFF151A24, mvrExpStarted);                            //!< End address: 0xFF151A70; Flags: 0x0 
NSTUB(0xFF1519CC, mvrFirstExposure);                         //!< End address: 0xFF151A24; Flags: 0x0 
NSTUB(0xFF17C218, mvrFixQScale);
NSTUB(0xFF152804, mvrFrameWrite);                            //!< End address: 0xFF152AA8; Flags: 0x0 
NSTUB(0xFF1526B4, mvrFrameWriteCBR);                         //!< End address: 0xFF152720; Flags: 0x0 
NSTUB(0xFF152618, mvrGetBufferUsage);                        //!< End address: 0xFF1526B4; Flags: 0x0 
NSTUB(0xFF1540FC, mvrIgnore);                                //!< End address: 0xFF15412C; Flags: 0x0 
NSTUB(0xFF14FF98, mvrMovStreamCallback);                     //!< End address: 0xFF14FFD4; Flags: 0x0 
NSTUB(0xFF14FFD4, mvrMovWorkCallback);                       //!< End address: 0xFF150020; Flags: 0x0 
NSTUB(0xFF1534EC, mvrReSuspend);                             //!< End address: 0xFF153528; Flags: 0x0 
NSTUB(0xFF151644, mvrRecForceStop);                          //!< End address: 0xFF1516F8; Flags: 0x0 
NSTUB(0xFF153558, mvrRecResume);                             //!< End address: 0xFF15375C; Flags: 0x0 
NSTUB(0xFF150060, mvrRecStart);                              //!< End address: 0xFF150798; Flags: 0x0 
NSTUB(0xFF151544, mvrRecStop);                               //!< End address: 0xFF151644; Flags: 0x0 
NSTUB(0xFF1516F8, mvrRecStopped);                            //!< End address: 0xFF15183C; Flags: 0x0 
NSTUB(0xFF15334C, mvrRecSuspend);                            //!< End address: 0xFF1533D8; Flags: 0x0 
NSTUB(0xFF151A70, mvrRecordCBR);                             //!< End address: 0xFF151B98; Flags: 0x0 
NSTUB(0xFF153A00, mvrSMEncodeDone);                          //!< End address: 0xFF153ED0; Flags: 0x0 
NSTUB(0xFF153ED0, mvrSMFinish);                              //!< End address: 0xFF153F18; Flags: 0x0 
NSTUB(0xFF154054, mvrSMForceStop);                           //!< End address: 0xFF1540FC; Flags: 0x0 
NSTUB(0xFF153F3C, mvrSMResume);                              //!< End address: 0xFF153F60; Flags: 0x0 
NSTUB(0xFF154030, mvrSMStop);                                //!< End address: 0xFF154054; Flags: 0x0 
NSTUB(0xFF153F18, mvrSMSuspend);                             //!< End address: 0xFF153F3C; Flags: 0x0 
NSTUB(0xFF17C06C, mvrSetD_FULLHD);                           //!< End address: 0xFF17C0A4; Flags: 0x0 
NSTUB(0xFF17C1A8, mvrSetD_VGA);
NSTUB(0xFF17BD34, mvrSetDeblockingFilter);                   //!< End address: 0xFF17BD6C; Flags: 0x0 
NSTUB(0xFF17C1E0, mvrSetDefDBFilter);
NSTUB(0xFF17BDA4, mvrSetDefQScale);                          //!< End address: 0xFF17BDC0; Flags: 0x0 
NSTUB(0xFF17BDDC, mvrSetFullHDOptSize);                      //!< End address: 0xFF17BE14; Flags: 0x0 
NSTUB(0xFF17BF94, mvrSetGopOptSizeFULLHD);                   //!< End address: 0xFF17BFDC; Flags: 0x0 
NSTUB(0xFF17BFDC, mvrSetGopOptSizeHD);                       //!< End address: 0xFF17C024; Flags: 0x0 
NSTUB(0xFF17C024, mvrSetGopOptSizeVGA);                      //!< End address: 0xFF17C06C; Flags: 0x0 
NSTUB(0xFF17BF24, mvrSetHDOptSize);
NSTUB(0xFF17BD6C, mvrSetLimitQScale);                        //!< End address: 0xFF17BDA4; Flags: 0x0 
NSTUB(0xFF151B98, mvrSetOutputAddress);                      //!< End address: 0xFF152004; Flags: 0x0 
NSTUB(0xFF17C238, mvrSetPrintMovieLog);
NSTUB(0xFF17BCD4, mvrSetQscale);                             //!< End address: 0xFF17BCFC; Flags: 0x0 
NSTUB(0xFF17BCFC, mvrSetQscaleYC);                           //!< End address: 0xFF17BD34; Flags: 0x0 
NSTUB(0xFF15388C, mvrSetShutterSound);                       //!< End address: 0xFF153A00; Flags: 0x0 
NSTUB(0xFF17BDC0, mvrSetTimeConst);                          //!< End address: 0xFF17BDDC; Flags: 0x0 
NSTUB(0xFF17BF5C, mvrSetVGAOptSize);
NSTUB(0xFF1524CC, mvrSoundWrite);                            //!< End address: 0xFF152564; Flags: 0x0 
NSTUB(0xFF150F18, mvrSoundWriteCBR);                         //!< End address: 0xFF150F48; Flags: 0x0 
NSTUB(0xFF150F48, mvrStopMovWriter);                         //!< End address: 0xFF151298; Flags: 0x0 
NSTUB(0xFF151384, mvrStopSoundDevice);                       //!< End address: 0xFF151420; Flags: 0x0 
NSTUB(0xFF153528, mvrSuspendCancel);                         //!< End address: 0xFF153558; Flags: 0x0 
NSTUB(0xFF151298, mvrTerminateEncoder);                      //!< End address: 0xFF151384; Flags: 0x0 
NSTUB(0xFF1532A0, mvrWaitEncDone);                           //!< End address: 0xFF1532FC; Flags: 0x0 
NSTUB(0xFF1532FC, mvrWaitSuspend);                           //!< End address: 0xFF15334C; Flags: 0x0 
NSTUB(0xFF1530CC, mvrWriteDone1);                            //!< End address: 0xFF153140; Flags: 0x0 
NSTUB(0xFF0104C0, objInfo);                                  //!< End address: 0xFF0104E0; Flags: 0x0 
NSTUB(0xFF0672B4, olddump);                                  //!< End address: 0xFF0672E4; Flags: 0x0 
NSTUB(0xFF067284, olddumpf);                                 //!< End address: 0xFF0672B4; Flags: 0x0 
NSTUB(0xFF06723C, oldgrep);                                  //!< End address: 0xFF067284; Flags: 0x0 
NSTUB(0xFF066F98, oldgrepsep);                               //!< End address: 0xFF066FE0; Flags: 0x0 
NSTUB(0xFF068268, oneshot_timer);                            //!< End address: 0xFF0682E8; Flags: 0x0 
NSTUB(0xFF20FAC0, pReceiveDataPhase);                        //!< End address: 0xFF20FC6C; Flags: 0x0 
NSTUB(0xFF0EB718, pfAfComplete);                             //!< End address: 0xFF0EB74C; Flags: 0x0 
NSTUB(0xFF0EB700, pfAfError);                                //!< End address: 0xFF0EB718; Flags: 0x0 
NSTUB(0xFF0ECF58, pfCompleteCBR);                            //!< End address: 0xFF0ECF98; Flags: 0x0 
NSTUB(0xFF18A404, phInitPropertyMaster);                     //!< End address: 0xFF18A470; Flags: 0x0 
NSTUB(0xFF2F4CE0, prepare_aes2);                             //!< End address: 0xFF2F4D20; Flags: 0x0 
NSTUB(0xFF01A630, prio);                                     //!< End address: 0xFF01A6A4; Flags: 0x0 
NSTUB(0xFF187148, propRegisterSlave);                        //!< End address: 0xFF187360; Flags: 0x0 
NSTUB(0xFF186DEC, propUnregisterMaster);                     //!< End address: 0xFF186E48; Flags: 0x0 
NSTUB(0xFF05993C, prop_cleanup);                             //!< End address: 0xFF059988; Flags: 0x0 
NSTUB(0xFF0597E0, prop_deliver);                             //!< End address: 0xFF059868; Flags: 0x0 
NSTUB(0xFF059868, prop_register_slave);                      //!< End address: 0xFF0598F8; Flags: 0x0 
NSTUB(0xFF059988, prop_request_change);                      //!< End address: 0xFF059A0C; Flags: 0x0 
NSTUB(0xFF1E117C, ptpSendStreamMemSuiteData);                //!< End address: 0xFF1E138C; Flags: 0x0 
NSTUB(0xFF20C404, ptp_register_handler);                     //!< End address: 0xFF20C4DC; Flags: 0x0 
NSTUB(0xFF0784E4, rand);                                     //!< End address: 0xFF078528; Flags: 0x0 
NSTUB(0xFF078528, randSem);                                  //!< End address: 0xFF078554; Flags: 0x0 
NSTUB(0xFF28B0DC, rand_sha_aes0);                            //!< End address: 0xFF28B308; Flags: 0x0 
NSTUB(0xFF2290B0, readMakernoteTag);                         //!< End address: 0xFF229178; Flags: 0x0 
NSTUB(0xFF16E1DC, receive_board_ids);                        //!< End address: 0xFF16E3DC; Flags: 0x0 
NSTUB(0xFF26E71C, rect);                                     //!< End address: 0xFF26E7FC; Flags: 0x0 
NSTUB(0xFF01C54C, register_func);                            //!< End address: 0xFF01C62C; Flags: 0x0 
NSTUB(0xFF01A778, resume);
NSTUB(0xFF218E44, sdioDrvCompleteJob);                       //!< End address: 0xFF218F00; Flags: 0x0 
NSTUB(0xFF2EC2EC, sdioTskConnectionChange);                  //!< End address: 0xFF2EC374; Flags: 0x0 
NSTUB(0xFF2EBF24, sdioTskInitialize);                        //!< End address: 0xFF2EC05C; Flags: 0x0 
NSTUB(0xFF2EC05C, sdioTskTerminate);                         //!< End address: 0xFF2EC2EC; Flags: 0x0 
NSTUB(0xFF088C80, sdsDDDParamGenerate);                      //!< End address: 0xFF088FE4; Flags: 0x0 
NSTUB(0xFF075984, sem);                                      //!< End address: 0xFF07598C; Flags: 0x0 
NSTUB(0xFF1C2668, setAdpProxyAddress);                       //!< End address: 0xFF1C2830; Flags: 0x0 
NSTUB(0xFF1C28C4, setAdpProxyPortNumber);                    //!< End address: 0xFF1C2A64; Flags: 0x0 
NSTUB(0xFF22E830, sha256_a);                                 //!< End address: 0xFF22E838; Flags: 0x0 
NSTUB(0xFF22E838, sha256_b);                                 //!< End address: 0xFF22E85C; Flags: 0x0 
NSTUB(0xFF2F69F4, sha256_related);                           //!< End address: 0xFF2F6A48; Flags: 0x0 
NSTUB(0xFF2F69C4, sha256_related2);
NSTUB(0xFF1B4A60, sharp);                                    //!< End address: 0xFF1B4A68; Flags: 0x0 
NSTUB(0xFF0BC2B4, smemShowFix);                              //!< End address: 0xFF0BCAAC; Flags: 0x0 
NSTUB(0xFF029898, smemTerm);                                 //!< End address: 0xFF029900; Flags: 0x0 
NSTUB(0xFF054B8C, sounddev_active_in);                       //!< End address: 0xFF054BC8; Flags: 0x0 
NSTUB(0xFF3C6164, startMnFirmVersionUp);                     //!< End address: 0xFF3C6258; Flags: 0x0 
NSTUB(0xFF013774, startupEntry);                             //!< End address: 0xFF0139A8; Flags: 0x0 
NSTUB(0xFF0134A0, startupErrorRequestChangeCBR);             //!< End address: 0xFF013580; Flags: 0x0 
NSTUB(0xFF014B70, startupInitializeComplete);                //!< End address: 0xFF014BF0; Flags: 0x0 
NSTUB(0xFF01429C, startupPrepareCapture);                    //!< End address: 0xFF0147BC; Flags: 0x0 
NSTUB(0xFF0147C8, startupPrepareDevelop);                    //!< End address: 0xFF0149B4; Flags: 0x0 
NSTUB(0xFF014A70, startupPreparePlayback);                   //!< End address: 0xFF014B70; Flags: 0x0 
NSTUB(0xFF013F88, startupPrepareProperty);                   //!< End address: 0xFF014034; Flags: 0x0 
NSTUB(0xFF014034, startupPrepareRemote);                     //!< End address: 0xFF01412C; Flags: 0x0 
NSTUB(0xFF07835C, strcpy);                                   //!< End address: 0xFF078374; Flags: 0x0 
NSTUB(0xFF01A7A0, suspend);
NSTUB(0xFF0104E0, sysConfig);                                //!< End address: 0xFF010500; Flags: 0x0 
NSTUB(0xFF0698D0, take_semaphore);                           //!< End address: 0xFF069988; Flags: 0x0 
NSTUB(0xFF018918, task);                                     //!< End address: 0xFF018920; Flags: 0x0 
NSTUB(0xFF06F714, taskShow);
NSTUB(0xFF069E2C, task_create);                              //!< End address: 0xFF069ED0; Flags: 0x0 
NSTUB(0xFF072B30, task_trampoline);                          //!< End address: 0xFF072B6C; Flags: 0x0 
NSTUB(0xFF077170, timer);
NSTUB(0xFF21C808, tomCancelOrder);                           //!< End address: 0xFF21CAE0; Flags: 0x0 
NSTUB(0xFF21BF34, tomChangeOrder);                           //!< End address: 0xFF21C290; Flags: 0x0 
NSTUB(0xFF21B700, tomClear);                                 //!< End address: 0xFF21B760; Flags: 0x0 
NSTUB(0xFF21CC54, tomDumpOrder);                             //!< End address: 0xFF21CCB0; Flags: 0x0 
NSTUB(0xFF21AF64, tomExecuteJob);                            //!< End address: 0xFF21AFC0; Flags: 0x0 
NSTUB(0xFF21CAE0, tomGetNumOfOrder);                         //!< End address: 0xFF21CBD4; Flags: 0x0 
NSTUB(0xFF21C34C, tomGetOrder);                              //!< End address: 0xFF21C478; Flags: 0x0 
NSTUB(0xFF21B69C, tomIsReadOnly);                            //!< End address: 0xFF21B700; Flags: 0x0 
NSTUB(0xFF21B780, tomSetOrder);                              //!< End address: 0xFF21BE7C; Flags: 0x0 
NSTUB(0xFF21B5D4, tomSetRawJpgMode);                         //!< End address: 0xFF21B608; Flags: 0x0 
NSTUB(0xFF21C478, tomStartOrder);                            //!< End address: 0xFF21C808; Flags: 0x0 
NSTUB(0xFF22EC94, updIcuEvDisptc);                           //!< End address: 0xFF22ED14; Flags: 0x0 
NSTUB(0xFF28AF1C, verifyFirmware);                           //!< End address: 0xFF28B00C; Flags: 0x0 
NSTUB(0xFF0783DC, verifyID);                                 //!< End address: 0xFF0784D8; Flags: 0x0 
NSTUB(0xFF28AE00, verifyUpdater);                            //!< End address: 0xFF28AF1C; Flags: 0x0 
NSTUB(0xFF23ABD4, vram_get_number);                          //!< End address: 0xFF23AC30; Flags: 0x0 
NSTUB(0xFF1A4398, vsnprintf);                                //!< End address: 0xFF1A474C; Flags: 0x0 
NSTUB(0xFF019D88, xd);                                       //!< End address: 0xFF01A1AC; Flags: 0x0 
